# -*- coding: UTF-8 -*-

from artix.common import logger
from common import config
import os

defaultLoggerConf = {
    'version': 1,
    'loggers': {
        '': {  # root logger
            'level': 'DEBUG',
            'handlers': ['exchangersHandler'],
            'propagate': False
        },
        'saleUnloadmain': {
            'level': 'DEBUG',
            'handlers': ['exchangersHandler'],
            'propagate': False
        },
        'saleUnloadNode': {
            'level': 'DEBUG',
            'handlers': ['exchangersHandler'],
            'propagate': False
        },
        'dictLoadmain': {
            'level': 'DEBUG',
            'handlers': ['exchangersHandler'],
            'propagate': False
        },
        'dictLoadNode': {
            'level': 'DEBUG',
            'handlers': ['exchangersHandler'],
            'propagate': False
        },
        'dictLoadrest': {
            'level': 'DEBUG',
            'handlers': ['exchangersHandler'],
            'propagate': False
        },
        'dictLoadsoap': {
            'level': 'DEBUG',
            'handlers': ['exchangersHandler'],
            'propagate': False
        },
        'dictLoadRestStatusService': {
            'level': 'DEBUG',
            'handlers': ['exchangersHandler'],
            'propagate': False
        },
        'Service': {
            'level': 'DEBUG',
            'handlers': ['exchangersHandler'],
            'propagate': False
        },
        'dict.rest.backup': {
            'level': 'DEBUG',
            'handlers': ['exchangersHandler'],
            'propagate': False
        }
    },
    'handlers': {
        'exchangersHandler': {
            'level': 'DEBUG',
            'formatter': 'exchangersFormatter',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': '/tmp/exchangers.log',
            'mode': 'a',
            'maxBytes': 5000000,
            'backupCount': 10
        }
    },
    'formatters': {
        'exchangersFormatter': {
            'format': '%(asctime)s %(thread)d %(levelname)-8s %(message)s %(module)5s(%(lineno)s)'
        }
    }
}


def getLogDirectory():
    return config.getString('main', 'logDirectory', '/tmp/exchangers')


def getUploadLogger(name, fileName=None):
    return getLogger(name, 'dictLoad', fileName)


def getUnloadLogger(name, fileName=None):
    return getLogger(name, 'saleUnload', fileName)


def getLogger(name, prefix='', fileName=None):
    name = prefix + name
    fileName = os.path.join(getLogDirectory(), ((prefix + fileName) if fileName else name) + '.log')
    # Возможно неободимо минимум 2 отдельных файла с ошибками - для upload и unload
    # В идеале под каждый сервис нужен отдельный файл
    errorsFilePath = config.getString('main', 'errorsFilePath', None) if config.isCash() else None
    return logger.SimpleLogger(fileName, name,
            configPath=os.path.join(os.path.dirname(os.path.realpath(__file__)), '../../config/%s/logging.properties' % ('cash' if config.isCash() else 'cs')),
            dictConfigObject=defaultLoggerConf, errorsFilePath=errorsFilePath).getLogger()
