# -*- coding: UTF-8 -*-

import datetime
import json


class Registry(object):
    path = '/linuxcash/cash/data/cash.reg'

    def __init__(self):
        with open(Registry.path, 'r') as f:
            self.json = json.load(f)

    def shopcode(self):
        return self.json["shopCode"]

    def cashcode(self):
        return self.json["cashCode"]

    def shift(self):
        return self.json["shiftNumber"]

    def checknum(self):
        return self.json["checkNumber"]

    def shiftStart(self):
        if self.json["shiftBeg"] == "":
            return None
        return datetime.datetime.strptime(self.json["shiftBeg"], "%Y-%m-%dT%H:%M:%S")
