# -*- coding: UTF-8 -*-

from sqlUnloader import SQLUnloader, CaseInsensitiveDict
from common import config, logger


class ShiftUnloader(SQLUnloader):
    def __init__(self, connection, log, storeId):
        self.cursor = connection.cursor()
        self.sdata = connection.cursor()
        self.dataInShift = connection.cursor()
        self.failedinputdata = connection.cursor()
        self.log = log
        self.storeId = storeId

    def unloadShiftObject(self, dict_lower):
        return {'cashCode': self.getValue(dict_lower, 'workshift.cashcode'),
                'shift': self.getValue(dict_lower, 'workshift.shiftnum'),
                'userCode': self.getValue(dict_lower, 'workshift.scode'),
                'timeBeg': self.getValue(dict_lower, 'workshift.time_beg'),
                'timeEnd': self.getValue(dict_lower, 'workshift.time_end'),
                'checkNum1': self.getValue(dict_lower, 'workshift.checknum1'),
                'checkNum2': self.getValue(dict_lower, 'workshift.checknum2'),
                'sumSale': self.getValue(dict_lower, 'workshift.sumsale'),
                'sumGain': self.getValue(dict_lower, 'workshift.sumgain'),
                'type': self.getValue(dict_lower, 'workshift.shifttype'),
                'shopcode': self.getValue(dict_lower, 'workshift.shopcode'),
                'sumDrawer': self.getValue(dict_lower, 'workshift.sumDrawer'),
                'update_time': self.getValue(dict_lower, 'workshift.update_time'),
                'users': [],
                'firstchecktime': self.getValue(dict_lower, 'workshift.firstchecktime'),
                'sumsalecash': self.getValue(dict_lower, 'workshift.sumsalecash'),
                'sumsalenoncash': self.getValue(dict_lower, 'workshift.sumsalenoncash'),
                'sumsaleother': self.getValue(dict_lower, 'workshift.sumsaleother'),
                'sumgaincash': self.getValue(dict_lower, 'workshift.sumgaincash'),
                'sumgainnoncash': self.getValue(dict_lower, 'workshift.sumgainnoncash'),
                'sumrefund': self.getValue(dict_lower, 'workshift.sumrefund'),
                'sumrefundcash': self.getValue(dict_lower, 'workshift.sumrefundcash'),
                'sumrefundnoncash': self.getValue(dict_lower, 'workshift.sumrefundnoncash'),
                'countsale': self.getValue(dict_lower, 'workshift.countsale'),
                'countrefund': self.getValue(dict_lower, 'workshift.countrefund'),
                'version': self.getValue(dict_lower, 'workshift.version')
                }

    def unloadUserObject(self, dict_lower):
        return {'usercode': self.getValue(dict_lower, 'users.usercode'), 
                'username': self.getValue(dict_lower, 'users.username'),
                'rank': self.getValue(dict_lower, 'users.rank')}
    def unloadCashierStatsObject(self, dict_lower):
        return {'scode': self.getValue(dict_lower, 'cashierstats.scode'),
                'cashcode': self.getValue(dict_lower, 'cashierstats.cashcode'),
                'date_beg': self.getValue(dict_lower, 'cashierstats.date_beg'),
                'shopcode': self.getValue(dict_lower, 'cashierstats.shopcode'),
                'sumsale': self.getValue(dict_lower, 'cashierstats.sumsale'),
                'sumgain': self.getValue(dict_lower, 'cashierstats.sumgain'),
                'sumsalecash': self.getValue(dict_lower, 'cashierstats.sumsalecash'),
                'sumsalenoncash': self.getValue(dict_lower, 'cashierstats.sumsalenoncash'),
                'sumsaleother': self.getValue(dict_lower, 'cashierstats.sumsaleother'),
                'sumrefund': self.getValue(dict_lower, 'cashierstats.sumrefund'),
                'sumrefundcash': self.getValue(dict_lower, 'cashierstats.sumrefundcash'),
                'sumrefundnoncash': self.getValue(dict_lower, 'cashierstats.sumrefundnoncash'),
                'countsale': self.getValue(dict_lower, 'cashierstats.countsale'),
                'countrefund': self.getValue(dict_lower, 'cashierstats.countrefund'),
                'countstorno': self.getValue(dict_lower, 'cashierstats.countstorno'),
                'countdisc': self.getValue(dict_lower, 'cashierstats.countdisc'),
                'sumstorno': self.getValue(dict_lower, 'cashierstats.sumstorno'),
                'timeaddposition': self.getValue(dict_lower, 'cashierstats.timeaddposition'),
                'countposition': self.getValue(dict_lower, 'cashierstats.countposition')}
    def unloadKKMObject(self, dict_lower):
        kkms = {'kkmNum': self.getValue(dict_lower, 'kkm.kkmnum'),
                'producerCode': self.getValue(dict_lower, 'kkm.producercode'),
                'producerName': self.getValue(dict_lower, 'kkm.producername'),
                'modelNum': self.getValue(dict_lower, 'kkm.modelnum'),
                'modelName': self.getValue(dict_lower, 'kkm.modelname'),
                'serialNum': self.getValue(dict_lower, 'kkm.serialnum'),
                'sumProtectedBeg': self.getValue(dict_lower, 'kkm.sumprotectedbeg'),
                'sumProtectedEnd': self.getValue(dict_lower, 'kkm.sumprotectedend'),
                'sumCashBeg': self.getValue(dict_lower, 'kkm.sumcashbeg'),
                'sumCashEnd': self.getValue(dict_lower, 'kkm.sumcashend'),
                'sumGain': self.getValue(dict_lower, 'kkm.sumgain'),
                'countSale': self.getValue(dict_lower, 'kkm.countsale'),
                'sumSale': self.getValue(dict_lower, 'kkm.sumsale'),
                'sumSaleEklz': self.getValue(dict_lower, 'kkm.sumsaleeklz'),
                'sumSaleByPayment1': self.getValue(dict_lower, 'kkm.sumsalebypayment1'),
                'sumSaleByPayment2': self.getValue(dict_lower, 'kkm.sumsalebypayment2'),
                'sumSaleByPayment3': self.getValue(dict_lower, 'kkm.sumsalebypayment3'),
                'sumSaleByPayment4': self.getValue(dict_lower, 'kkm.sumsalebypayment4'),
                'sumSaleByPayment5': self.getValue(dict_lower, 'kkm.sumsalebypayment5'),
                'sumSaleByPayment6': self.getValue(dict_lower, 'kkm.sumsalebypayment6'),
                'countBack': self.getValue(dict_lower, 'kkm.countback'),
                'sumBack': self.getValue(dict_lower, 'kkm.sumback'),
                'sumBackEklz': self.getValue(dict_lower, 'kkm.sumbackeklz'),
                'sumBackByPayment1': self.getValue(dict_lower, 'kkm.sumbackbypayment1'),
                'sumBackByPayment2': self.getValue(dict_lower, 'kkm.sumbackbypayment2'),
                'sumBackByPayment3': self.getValue(dict_lower, 'kkm.sumbackbypayment3'),
                'sumBackByPayment4': self.getValue(dict_lower, 'kkm.sumbackbypayment4'),
                'sumBackByPayment5': self.getValue(dict_lower, 'kkm.sumbackbypayment5'),
                'sumBackByPayment6': self.getValue(dict_lower, 'kkm.sumbackbypayment6'),
                'paymentName1': self.getValue(dict_lower, 'kkm.paymentname1'),
                'paymentName2': self.getValue(dict_lower, 'kkm.paymentname2'),
                'paymentName3': self.getValue(dict_lower, 'kkm.paymentname3'),
                'paymentName4': self.getValue(dict_lower, 'kkm.paymentname4'),
                'paymentName5': self.getValue(dict_lower, 'kkm.paymentname5'),
                'paymentName6': self.getValue(dict_lower, 'kkm.paymentname6'),
                'sumMoneyIn': self.getValue(dict_lower, 'kkm.summoneyin'),
                'countMoneyIn': self.getValue(dict_lower, 'kkm.countmoneyin'),
                'sumMoneyOut': self.getValue(dict_lower, 'kkm.summoneyout'),
                'countMoneyOut': self.getValue(dict_lower, 'kkm.countmoneyout'),
                'crashed': self.getValue(dict_lower, 'kkm.crashed'),
                'shiftnumkkm': self.getValue(dict_lower, 'kkm.shiftnumkkm'),
                'unsenddoccount': self.getValue(dict_lower, 'kkm.unsenddoccount'),
                'unsenddocdate': self.getValue(dict_lower, 'kkm.unsenddocdate'),
                'fnnumber': self.getValue(dict_lower, 'kkm.fnnumber'),
                }
        for columnName in ['sumsaledept', 'sumbackdept']:
            for num in range(1, 17):
                kkms['%s%s' % (columnName, num)] = self.getValue(dict_lower, 'kkm.%s%s' % (columnName, num))
        return kkms

    def unloadFailedInputObject(self, dict_lower):
        return {'failedinputid': self.getValue(dict_lower, 'failedinput.failedinputid'),
                'scode': self.getValue(dict_lower, 'failedinput.scode'),
                'data': self.getValue(dict_lower, 'failedinput.data'),
                'rawdata': self.getValue(dict_lower, 'failedinput.rawdata'),
                'inputsource': self.getValue(dict_lower, 'failedinput.inputsource'),
                'dtime': self.getValue(dict_lower, 'failedinput.dtime'),
                'success': self.getValue(dict_lower, 'failedinput.success'),
                'message': self.getValue(dict_lower, 'failedinput.message'),
                'datatype': self.getValue(dict_lower, 'failedinput.datatype'),
                }

    def unloadReportObject(self, dict_lower):
        return {'name': self.getValue(dict_lower, 'report.name'), 
                'reportdatetime': self.getValue(dict_lower, 'report.reportdatetime'),
                'rawdata': self.getValue(dict_lower, 'report.rawdata'),
                'reporttext': self.getValue(dict_lower, 'report.reporttext'),
                }

    def getClosedShiftsQueryEnd(self, closedShifts):
        queryEnd = ""
        if closedShifts == 0:
            queryEnd = " and s.`time_end` IS NOT NULL"
        elif closedShifts == 1:
            queryEnd = " and s.`time_end` IS NULL"
        return queryEnd

    def getStoreIdQueryPart(self):
        if not config.isCash():
            return " AND s.`storeId` = '%s' " % self.storeId
        return ''

    def getChangedShifts(self, cashCode, closedShifts):
        self.log.info(u'Получение измененных смен для кассы %s' % cashCode)
        queryEnd = self.getClosedShiftsQueryEnd(closedShifts)
        query = "select `workshiftid` from `workshift` s where s.`cashcode`=%s and s.`changed`=1" + self.getStoreIdQueryPart() + queryEnd
        self.cursor.execute(query, (cashCode,))
        return self.cursor.fetchall()

    def getShiftsByDate(self, cashCode, fromDate, toDate, closedShifts):
        self.log.info(u'Получение смен по датам с %s по %s для кассы %s' % (fromDate, toDate, cashCode))
        queryEnd = self.getClosedShiftsQueryEnd(closedShifts)
        query = "select `workshiftid` from `workshift` s where s.`cashcode` = %(cashCode)s " + self.getStoreIdQueryPart() \
            + " AND (( (%(fromDate)s IS NULL OR %(fromDate)s <= `time_beg`) AND (%(toDate)s IS NULL OR `time_beg` <= %(toDate)s)) OR \
                  ((%(fromDate)s IS NULL OR %(fromDate)s <= `time_end`) AND (%(toDate)s IS NULL OR `time_end` <= %(toDate)s)) OR \
                  ((%(fromDate)s IS NULL OR `time_beg` <= %(fromDate)s) AND (%(toDate)s IS NULL OR %(toDate)s <= `time_end` OR `time_end` IS NULL)))" + queryEnd
        self.cursor.execute(query, {'cashCode':cashCode, 'fromDate':fromDate, 'toDate':toDate})
        return self.cursor.fetchall()

    def getShiftsByShiftnum(self, cashCode, fromShift, toShift, closedShifts):
        self.log.info(u'Получение смен с номера %s по %s для кассы %s' % (fromShift, toShift, cashCode))
        queryEnd = self.getClosedShiftsQueryEnd(closedShifts)
        query = "select `workshiftid` from `workshift` s where `cashcode` = %s and \
            (%s IS NULL or `shiftnum` >= %s) and (%s IS NULL or `shiftnum` <= %s)" + self.getStoreIdQueryPart() + queryEnd
        self.cursor.execute(query, (cashCode, fromShift, fromShift, toShift, toShift,))
        return self.cursor.fetchall()

    def getShiftsByDocumentDate(self, cashCode, fromDate, toDate):
        self.log.info(u'Получение смен по датам документов с %s по %s для кассы %s' % (fromDate, toDate, cashCode))
        forcedids = []
        if fromDate:
            # на кассе и КС разные названия поля с временем изменения записи в таблице fiscaldocument
            timeFieldName = 'updatetime' if config.isCash() else 'update_time'
            query = 'SELECT documentid FROM fiscaldocument WHERE fiscaldocument.{timeField} > %s AND (%s is NULL OR fiscaldocument.{timeField} <= %s)'.format(timeField=timeFieldName)
            self.cursor.execute(query, (fromDate, toDate, toDate,))
            for dictParams in self.cursor:
                for param in dictParams.values():
                    forcedids.append(str(param))
        forcedids = tuple(forcedids)
        query = "select `workshiftid` from `workshift` s where `cashcode` = %s " + self.getStoreIdQueryPart() + " AND (`workshiftid` IN \
                            (SELECT DISTINCT `workshiftid` FROM `document` WHERE ((%s IS NULL or `time_end` > %s) AND (%s IS NULL or `time_end` <= %s)) OR (`documentid` IN %s)) OR \
                            ((%s IS NULL or `time_end` > %s) AND (%s IS NULL or `time_end` <= %s)))"
        self.cursor.execute(query, (cashCode, fromDate, fromDate, toDate, toDate, forcedids, fromDate, fromDate, toDate, toDate,))
        return self.cursor.fetchall()

    def unloadUsers(self, shiftid):
        query = "select * from `users` where `workshiftid` = %s"
        self.dataInShift.execute(query, (shiftid,))
        for row in self.dataInShift:
            yield self.unloadUserObject(CaseInsensitiveDict(row))

    def unloadKKMs(self, shiftid):
        query = "select * from `kkm` where `workshiftid` = %s"
        self.dataInShift.execute(query, (shiftid,))
        for row in self.dataInShift:
            yield self.unloadKKMObject(CaseInsensitiveDict(row))

    def unloadFailedInputData(self, shiftid):
        self.failedinputdata.execute('SELECT * FROM `failedinput` WHERE `workshiftid` = %s', (shiftid,))
        for row in self.failedinputdata:
            yield self.unloadFailedInputObject(CaseInsensitiveDict(row))

    def unloadReports(self, shiftid):
        query = "select * from `report` where `workshiftid` = %s"
        self.dataInShift.execute(query, (shiftid,))
        for row in self.dataInShift:
            yield self.unloadReportObject(CaseInsensitiveDict(row))
    def unloadCashierStats(self, shiftid):
        query = "select * from `cashierstats` where `workshiftid` = %s"
        self.dataInShift.execute(query, (shiftid,))
        for row in self.dataInShift:
            yield self.unloadCashierStatsObject(CaseInsensitiveDict(row))

    def unloadShifts(self, shifts):
        if shifts:
            self.log.info('unload shifts %s' % (shifts,))
            query = "select * from `workshift` where `workshiftid` IN %s"
            self.sdata.execute(query, (shifts,))
            for row in self.sdata:
                dict_lower = CaseInsensitiveDict(row)
                shift = self.unloadShiftObject(dict_lower)
                workshiftid = self.getValue(dict_lower, 'workshiftid')
                shift['users'] = [pos for pos in self.unloadUsers(workshiftid)]
                shift['kkms'] = [pos for pos in self.unloadKKMs(workshiftid)]
                shift['failedinput'] = [pos for pos in self.unloadFailedInputData(workshiftid)]
                shift['reports'] = [pos for pos in self.unloadReports(workshiftid)]
                shift['cashierstats'] = [pos for pos in self.unloadCashierStats(workshiftid)]
                yield shift
        else:
            self.log.info(u'Нет смен за указанный период')

    def getShiftsByDocumentDateForShop(self, fromDate, toDate, cashList):
        self.log.info(u'Получение смен по датам документа с %s по %s для касс %s' % (fromDate, toDate, cashList))
        query = "select `workshiftid` from `workshift` s where `cashcode` IN %s " + self.getStoreIdQueryPart() + " AND (`workshiftid` IN \
                            (SELECT DISTINCT `workshiftid` FROM `document` WHERE (%s IS NULL or `time_end` > %s) AND (%s IS NULL or `time_end` <= %s)) OR \
                            ((%s IS NULL or `time_end` > %s) AND (%s IS NULL or `time_end` <= %s)))"
        self.cursor.execute(query, (tuple(cashList), fromDate, fromDate, toDate, toDate, fromDate, fromDate, toDate, toDate,))
        return self.cursor.fetchall()

    def getShiftsByShiftsForShop(self, fromShift, toShift, cashList, closedShifts):
        self.log.info(u'Получение смен с номера %s по %s для касс %s' % (fromShift, toShift, cashList))
        queryEnd = self.getClosedShiftsQueryEnd(closedShifts)
        query = "select `workshiftid` from `workshift` s where `cashcode` IN %s and (%s IS NULL or `shiftnum` >= %s) and (%s IS NULL or `shiftnum` <= %s)" + self.getStoreIdQueryPart() + queryEnd
        self.cursor.execute(query, (tuple(cashList), fromShift, fromShift, toShift, toShift,))
        return self.cursor.fetchall()

    def getOpenedShiftsToDay(self, cashCode):
        self.log.info(u'Получение открытых смен за сегодня для кассы №%s' % cashCode)
        query = "SELECT `workshiftid` FROM `workshift` WHERE `cashcode` = %s AND (DATE(`time_beg`) = CURDATE() AND (DATE(`time_end`) = CURDATE() OR `time_end` IS NULL) OR (`time_beg` IS NULL and `time_end` IS NULL));"
        self.cursor.execute(query, (cashCode,))
        return self.cursor.fetchall()
