import sys
if sys.version_info.major == 3:
    import collections.abc as collections
else:
    import collections as collections

class CaseInsensitiveDict(collections.Mapping):
    def __init__(self, d):
        self._d = d
        self._s = dict((k.lower(), k) for k in d)

    def __contains__(self, k):
        return k.lower() in self._s

    def __len__(self):
        return len(self._s)

    def __iter__(self):
        return iter(self._s)

    def __getitem__(self, k):
        return self._d[self._s[k.lower()]]

    def actual_key_case(self, k):
        return self._s.get(k.lower())


class SQLUnloader(object):
    def getValue(self, dict_lower, column):
        value = dict_lower.get(column)
        if value is None:
            column = column.split('.')
            if len(column) == 2:
                value = dict_lower.get(column[1])
        return value
