# -*- coding: UTF-8 -*-
import time

from upload.fam.session import _SessionService


class RestDictSession(object):
    def __init__(self, node, dictId, inserter):
        self.node = node
        self.dictId = dictId
        self.timeActive = time.time()
        self.inserter = inserter


class RestSessionService(_SessionService):
    is_cash = True
    default_nes_server = None
    default_status_server = None
    is_inserter_start = False

    def __init__(self, is_cash=True, default_nes_server=None, default_status_server=None):
        super(RestSessionService, self).__init__(loggerType='rest')
        self.is_cash = is_cash
        self.default_nes_server = default_nes_server
        self.default_status_server = default_status_server

    def start_session_worker(self, node, dictionary_id):
        plugin = __import__('upload.inserter.%s' % node.inserter.name, fromlist='Inserter')
        cl = getattr(plugin, 'Inserter')
        inserter = cl(node)
        inserter.disableProgressFile = False
        inserter.source = "exchangers-rest-upload"
        self.is_inserter_start = inserter.start()
        if self.is_inserter_start:
            self.sessions[self.get_session_id(node.id, dictionary_id)] = RestDictSession(node, dictionary_id, inserter)
            return {u'success': True, 'info': "Session for shopCode: %s and dictionary: %s successfully open" % (
                node.id, dictionary_id),
                    'info_ru': u'Сессия для магазина с кодом: %s и справочником: %s успешно открыта.' % (
                        node.id, dictionary_id)}
        return {u'success': False, 'info': "Error while opening session for shopCode: %s and dictionary: %s" % (
            node.id, dictionary_id),
                'info_ru': u'В процессе открытия сессии для магазина с кодом: %s и справочником %s произошла ошибка.' % (
                    node.id, dictionary_id)}

    def stop_session_worker(self, node):
        return node.inserter.stop()

    def rollback_session_worker(self, node, session_idle):
        return node.inserter.rollback()
